
f=inline('1./(1+x.^2)');
z=linspace(-5,5,500);

subplot(2,1,1);
plot(z,f(z),'k');
hold on

subplot(2,1,2);
plot(z,f(z),'k');
hold on

subplot(2,1,1);
m=colormap(autumn(20));
for n=4:4:20
    x=linspace(-5,5,n);
    p=polyfit(x,f(x),n-1);
    plot(z,polyval(p,z),'Color',m(n,:));
end
hold off

subplot(2,1,2);
m=colormap(autumn(20));
for n=4:4:20
    x=1:n;
    x=5*cos((2*x-1)*pi/(2*n));
    p=polyfit(x,f(x),n-1);
    plot(z,polyval(p,z),'Color',m(n,:));
end
hold off